## kfreebsd-8 8.2

=== sys/boot/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

.if ${MK_FORTH} != "no"
# Build the add-in FORTH interpreter.
SUBDIR+=		ficl
.endif

# Build EFI library.
.if ${MACHINE_ARCH} == "amd64" || ${MACHINE} == "i386" || ${MACHINE_ARCH} == "ia64"
SUBDIR+=		efi
.endif

# Build Open Firmware library.
.if ${MACHINE_ARCH} == "powerpc" || ${MACHINE_ARCH} == "sparc64"
SUBDIR+=		ofw
.endif

# Build U-Boot library.
.if ${MACHINE_ARCH} == "powerpc" || ${MACHINE_ARCH} == "arm"
SUBDIR+=		uboot
.endif

.if ${MACHINE_ARCH} == "amd64" || ${MACHINE} == "i386"
SUBDIR+=		zfs
.endif

# Pick the machine-dependent subdir based on the target architecture.
ADIR=			${MACHINE:S/amd64/i386/:S/sun4v/sparc64/}
.if exists(${.CURDIR}/${ADIR}/.)
SUBDIR+=		${ADIR}
.endif

.include <bsd.subdir.mk>

=== sys/i386/Makefile ===
# $FreeBSD$
#	@(#)Makefile	8.1 (Berkeley) 6/11/93

# Makefile for i386 links, tags file

# SYS is normally set in Make.tags.inc
SYS=/sys

TAGDIR=	i386

.include "../kern/Make.tags.inc"

all:
	@echo "make links or tags only"

# Directories in which to place i386 tags links
DI386=	apm i386 ibcs2 include isa linux

links::
	-for i in ${COMMDIR1}; do \
	    (cd $$i && { rm -f tags; ln -s ../${TAGDIR}/tags tags; }) done
	-for i in ${COMMDIR2}; do \
	    (cd $$i && { rm -f tags; ln -s ../../${TAGDIR}/tags tags; }) done
	-for i in ${DI386}; do \
	    (cd $$i && { rm -f tags; ln -s ../tags tags; }) done

SI386=	${SYS}/i386/acpica/*.[ch] ${SYS}/i386/bios/*.[ch] \
	${SYS}/i386/cpufreq/*.[ch] ${SYS}/i386/pci/*.[ch] \
	${SYS}/i386/i386/*.[ch] ${SYS}/i386/ibcs2/*.[ch] \
	${SYS}/i386/include/*.[ch] ${SYS}/i386/isa/*.[ch] \
	${SYS}/i386/linux/*.[ch]
AI386=	${SYS}/i386/i386/*.s

tags::
	-ctags -wdt ${COMM} ${SI386}
	egrep "^ENTRY(.*)|^ALTENTRY(.*)" ${AI386} | \
	    sed "s;\([^:]*\):\([^(]*\)(\([^, )]*\)\(.*\);\3 \1 /^\2(\3\4$$/;" \
		>> tags
	sort -o tags tags
	chmod 444 tags

=== sys/modules/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

SUBDIR=	${_3dfx} \
	${_3dfx_linux} \
	${_aac} \
	accf_data \
	accf_dns \
	accf_http \
	${_acpi} \
	ae \
	${_aesni} \
	age \
	${_agp} \
	aha \
	${_ahb} \
	ahci \
	${_aic} \
	aic7xxx \
	aio \
	alc \
	ale \
	alq \
	${_amd} \
	${_amdsbwd} \
	${_amdtemp} \
	amr \
	${_an} \
	${_aout} \
	${_apm} \
	${_arcmsr} \
	${_arcnet} \
	${_asmc} \
	${_asr} \
	ata \
	ath \
	${_auxio} \
	${_bce} \
	bfe \
	bge \
	${_bios} \
	${_bktr} \
	${_bm} \
	bridgestp \
	${_bwi} \
	${_bwn} \
	cam \
	${_canbepm} \
	${_canbus} \
	${_cardbus} \
	cas \
	${_cbb} \
	cd9660 \
	cd9660_iconv \
	${_ce} \
	${_ciss} \
	${_cm} \
	${_cmx} \
	coda \
	coda5 \
	${_coff} \
	${_coretemp} \
	${_cp} \
	${_cpuctl} \
	${_cpufreq} \
	${_crypto} \
	${_cryptodev} \
	${_cs} \
	${_ctau} \
	${_cxgb} \
	${_cyclic} \
	dc \
	dcons \
	dcons_crom \
	de \
	${_dpms} \
	${_dpt} \
	${_drm} \
	${_dtrace} \
	dummynet \
	${_ed} \
	${_elink} \
	${_em} \
	en \
	${_ep} \
	${_epic} \
	${_et} \
	${_ex} \
	${_exca} \
	${_ext2fs} \
	fatm \
	fdc \
	fdescfs \
	${_fe} \
	firewire \
	firmware \
	fxp \
	gem \
	geom \
	${_glxsb} \
	hatm \
	hifn \
	hme \
	${_hptiop} \
	${_hptmv} \
	${_hptrr} \
	hwpmc \
	${_i2c} \
	${_ibcs2} \
	${_ichwd} \
	${_ida} \
	${_ie} \
	if_bridge \
	if_carp \
	if_disc \
	if_edsc \
	if_ef \
	if_epair \
	if_faith \
	if_gif \
	if_gre \
	if_lagg \
	${_if_ndis} \
	if_stf \
	if_tap \
	if_tun \
	if_vlan \
	${_igb} \
	${_iir} \
	${_io} \
	ipdivert \
	${_ipfilter} \
	ipfw \
	ipfw_nat \
	${_ipmi} \
	ip_mroute_mod \
	${_ips} \
	${_ipw} \
	${_ipwfw} \
	iscsi \
	isp \
	ispfw \
	${_iwi} \
	${_iwifw} \
	${_iwn} \
	${_iwnfw} \
	${_ixgb} \
	${_ixgbe} \
	jme \
	joy \
	kbdmux \
	krpc \
	ksyms \
	le \
	lge \
	libalias \
	libiconv \
	libmbpool \
	libmchain \
	${_lindev} \
	${_linprocfs} \
	${_linsysfs} \
	${_linux} \
	lmc \
	lpt \
	mac_biba \
	mac_bsdextended \
	mac_ifoff \
	mac_lomac \
	mac_mls \
	mac_none \
	mac_partition \
	mac_portacl \
	mac_seeotheruids \
	mac_stub \
	mac_test \
	malo \
	mcd \
	md \
	mem \
	${_mfi} \
	mii \
	mlx \
	${_mly} \
	mmc \
	mmcsd \
	${_mpt} \
	mqueue \
	msdosfs \
	msdosfs_iconv \
	${_mse} \
	msk \
	mvs \
	mwl \
	mwlfw \
	mxge \
	my \
	${_ncp} \
	${_ncv} \
	${_ndis} \
	${_netgraph} \
	${_nfe} \
	nfs_common \
	nfscl \
	nfsclient \
	nfscommon \
	nfsd \
	nfslock \
	nfslockd \
	nfsserver \
	nfssvc \
	nge \
	nmdm \
	${_nsp} \
	ntfs \
	ntfs_iconv \
	nullfs \
	${_nve} \
	${_nvram} \
	${_nwfs} \
	${_nxge} \
	${_opensolaris} \
	${_padlock} \
	patm \
	${_pccard} \
	${_pcfclock} \
	pcn \
	${_pf} \
	${_pflog} \
	plip \
	${_pmc} \
	portalfs \
	ppbus \
	ppc \
	ppi \
	pps \
	procfs \
	pseudofs \
	${_pst} \
	puc \
	ral \
	ralfw \
	${_random} \
	rc4 \
	${_rdma} \
	re \
	reiserfs \
	rl \
	runfw \
	${_s3} \
	${_safe} \
	${_sbni} \
	scc \
	scd \
	${_scsi_low} \
	sdhci \
	sem \
	sf \
	sge \
	${_siba_bwn} \
	siftr \
	siis \
	sis \
	sk \
	${_smbfs} \
	sn \
	${_snc} \
	snp \
	${_sound} \
	${_speaker} \
	${_splash} \
	${_sppp} \
	ste \
	${_stg} \
	stge \
	${_streams} \
	${_svr4} \
	${_sym} \
	${_syscons} \
	sysvipc \
	ti \
	tl \
	${_tmpfs} \
	${_tpm} \
	trm \
	${_twa} \
	twe \
	tx \
	txp \
	${_uart} \
	ubsec \
	udf \
	udf_iconv \
	ufs \
	unionfs \
	usb \
	utopia \
	${_vesa} \
	vge \
	vkbd \
	${_vpo} \
	vr \
	vx \
	wb \
	${_wi} \
	wlan \
	wlan_acl \
	wlan_amrr \
	wlan_ccmp \
	wlan_rssadapt \
	wlan_tkip \
	wlan_wep \
	wlan_xauth \
	${_wpi} \
	${_wpifw} \
	${_x86bios} \
	${_xe} \
	xfs \
	xl \
	${_zfs} \
	zlib \

.if ${MACHINE_ARCH} != "powerpc" && ${MACHINE_ARCH} != "arm" && \
	${MACHINE_ARCH} != "mips"
_syscons=	syscons
_vpo=		vpo
.endif

.if ${MACHINE_ARCH} != "arm" && ${MACHINE_ARCH} != "mips"
# no BUS_SPACE_UNSPECIFIED
_bce=		bce
_bwi=		bwi
_bwn=		bwn
_mfi=		mfi
_mpt=		mpt
_siba_bwn=	siba_bwn
# No barrier instruction support (specific to this driver)
_sym=		sym
# no uart_cpu_$MACHINE_ARCH
_uart=		uart
# disable_intr() interferes
_cxgb=		cxgb
.endif

.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
.if exists(${.CURDIR}/../opencrypto)
_crypto=	crypto
_cryptodev=	cryptodev
.endif
.if exists(${.CURDIR}/../crypto)
_random=	random
.endif
.endif

.if ${MK_IPFILTER} != "no" || defined(ALL_MODULES)
_ipfilter=	ipfilter
.endif

.if ${MK_NETGRAPH} != "no" || defined(ALL_MODULES)
_netgraph=	netgraph
.endif

.if ${MK_PF} != "no" || defined(ALL_MODULES)
_pf=		pf
_pflog=		pflog
.endif

.if ${MACHINE_ARCH} == "i386"
# XXX some of these can move to the general case when de-i386'ed
# XXX some of these can move now, but are untested on other architectures.
_3dfx=		3dfx
_3dfx_linux=	3dfx_linux
_agp=		agp
_aic=		aic
_amd=		amd
_an=		an
_aout=		aout
_apm=		apm
_arcnet=	arcnet
_bktr=		bktr
_cardbus=	cardbus
_cbb=		cbb
_ce=		ce
_coff=		coff
_cp=		cp
_cpuctl=	cpuctl
_cpufreq=	cpufreq
_cs=		cs
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_cyclic=	cyclic
.endif
_dpms=		dpms
_drm=		drm
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_elink=		elink
_em=		em
_ep=		ep
_et=		et
_exca=		exca
_ext2fs=	ext2fs
_fe=		fe
_glxsb=		glxsb
_i2c=		i2c
_ibcs2=		ibcs2
_ie=		ie
_if_ndis=	if_ndis
_igb=		igb
_io=		io
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_mse=		mse
.if ${MK_NCP} != "no"
_ncp=		ncp
.endif
_ncv=		ncv
_ndis=		ndis
_nsp=		nsp
.if ${MK_NCP} != "no"
_nwfs=		nwfs
.endif
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
_pccard=	pccard
_pcfclock=	pcfclock
_pst=		pst
_rdma=		rdma
_safe=		safe
_sbni=		sbni
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_stg=		stg
_streams=	streams
_svr4=		svr4
_tmpfs=		tmpfs
_wi=		wi
_xe=		xe
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.if ${MACHINE} == "i386"
_aac=		aac
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_ahb=		ahb
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_asr=		asr
_bios=		bios
_ciss=		ciss
_cm=		cm
_cmx=		cmx
_coretemp=	coretemp
_ctau=		ctau
_dpt=		dpt
_ex=		ex
_hptiop=	hptiop
_hptmv=		hptmv
_hptrr=		hptrr
_ichwd=		ichwd
_ida=		ida
_iir=		iir
_ipmi=		ipmi
_ips=		ips
_ipw=		ipw
_ipwfw=		ipwfw
_iwi=		iwi
_iwifw=		iwifw
_iwn=		iwn
_iwnfw=		iwnfw
_ixgb=		ixgb
_ixgbe=		ixgbe
_mly=		mly
_nfe=		nfe
_nve=		nve
_nvram=		nvram
_nxge=		nxge
_tpm=		tpm
_wpi=		wpi
_wpifw=		wpifw
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_s3=		s3
_twa=		twa
_vesa=		vesa
_x86bios=	x86bios
.elif ${MACHINE} == "pc98"
_canbepm=	canbepm
_canbus=	canbus
_pmc=		pmc
_snc=		snc
.endif
.endif

.if ${MACHINE_ARCH} == "amd64"
_aac=		aac
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_agp=		agp
_an=		an
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_cardbus=	cardbus
_cbb=		cbb
_cmx=		cmx
_ciss=		ciss
_coretemp=	coretemp
_cpuctl=	cpuctl
_cpufreq=	cpufreq
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_cyclic=	cyclic
.endif
_dpms=		dpms
_drm=		drm
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_et=		et
_em=		em
_exca=		exca
_ext2fs=	ext2fs
_hptiop=	hptiop
_hptmv=		hptmv
_hptrr=		hptrr
_i2c=		i2c
_ichwd=		ichwd
_ida=		ida
_if_ndis=	if_ndis
_igb=		igb
_iir=		iir
_io=		io
_ipmi=		ipmi
_ips=		ips
_ipw=		ipw
_ipwfw=		ipwfw
_iwi=		iwi
_iwifw=		iwifw
_iwn=		iwn
_iwnfw=		iwnfw
_ixgb=		ixgb
_ixgbe=		ixgbe
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_mly=		mly
_ndis=		ndis
_nfe=		nfe
_nve=		nve
_nvram=		nvram
_nxge=		nxge
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_pccard=	pccard
_rdma=		rdma	
_s3=		s3
_safe=		safe
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_tmpfs=		tmpfs
_tpm=		tpm
_twa=		twa
_vesa=		vesa
_x86bios=	x86bios
_wi=		wi
_wpi=		wpi
_wpifw=		wpifw
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.endif

.if ${MACHINE_ARCH} == "ia64"
_aac=		aac
_aic=		aic
_an=		an
_arcnet=	arcnet
_asr=		asr
_bktr=		bktr
_cardbus=	cardbus
_cbb=		cbb
_ciss=		ciss
_cm=		cm
_cmx=		cmx
_coff=		coff
_cpufreq=	cpufreq
_dpt=		dpt
_em=		em
_ep=		ep
_et=		et
_exca=		exca
_fe=		fe
_hptiop=	hptiop
_ida=		ida
_igb=		igb
_iir=		iir
_ips=		ips
_mly=		mly
_pccard=	pccard
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_splash=	splash
_sppp=		sppp
_streams=	streams
_tpm=		tpm
_twa=		twa
_wi=		wi
_xe=		xe
.endif

.if ${MACHINE_ARCH} == "powerpc"
_an=		an
_bm=		bm
_cpufreq=	cpufreq
_nvram=		powermac_nvram
_smbfs=		smbfs
_sound=		sound
.endif

.if ${MACHINE_ARCH} == "sparc64"
_auxio=		auxio
_em=		em
_epic=		epic
_i2c=		i2c
_igb=		igb
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
_sound=		sound
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.endif

.if defined(MODULES_OVERRIDE) && !defined(ALL_MODULES)
SUBDIR=${MODULES_OVERRIDE}
.endif

.for reject in ${WITHOUT_MODULES}
SUBDIR:= ${SUBDIR:N${reject}}
.endfor

# Calling kldxref(8) for each module is expensive.
.if !defined(NO_XREF)
.MAKEFLAGS+=	-DNO_XREF
afterinstall:
	@if type kldxref >/dev/null 2>&1; then \
		${ECHO} kldxref ${DESTDIR}${KMODDIR}; \
		kldxref ${DESTDIR}${KMODDIR}; \
	fi
.endif

.include <bsd.subdir.mk>

=== sys/amd64/linux32/Makefile ===
# Makefile for syscall tables
#
# $FreeBSD$

all:
	@echo "make sysent only"

sysent:  linux32_sysent.c linux32_syscall.h linux32_proto.h

linux32_sysent.c linux32_syscall.h linux32_proto.h: ../../kern/makesyscalls.sh \
		syscalls.master syscalls.conf
	-mv -f linux32_sysent.c linux32_sysent.c.bak
	-mv -f linux32_syscall.h linux32_syscall.h.bak
	-mv -f linux32_proto.h linux32_proto.h.bak
	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf

=== sys/boot/zfs/Makefile ===
# $FreeBSD$

LIB=		zfsboot
INTERNALLIB=

SRCS+=		zfs.c

CFLAGS+=	-DBOOTPROG=\"zfsloader\"
CFLAGS+=	-I${.CURDIR}/../common -I${.CURDIR}/../.. -I.
CFLAGS+=	-I${.CURDIR}/../../../lib/libstand
CFLAGS+=	-I${.CURDIR}/../../cddl/boot/zfs

CFLAGS+=	-ffreestanding
.if ${MACHINE_ARCH} == "i386" || ${MACHINE_ARCH} == "amd64"
CFLAGS+=	-mpreferred-stack-boundary=2
CFLAGS+=	-mno-mmx -mno-3dnow -mno-sse -mno-sse2
.endif
.if ${MACHINE_ARCH} == "i386"
CFLAGS+=	-mno-sse3
.endif
.if ${MACHINE_ARCH} == "powerpc" || ${MACHINE_ARCH} == "arm"
CFLAGS+=	-msoft-float
.endif
.if ${MACHINE_ARCH} == "amd64"
CFLAGS+=	-m32 -march=i386
.endif

CFLAGS+=	-Wformat -Wall

.if ${MACHINE_ARCH} == "amd64"
CLEANFILES+=    machine
machine:
	ln -sf ${.CURDIR}/../../i386/include machine
.endif

.include <bsd.lib.mk>

.if ${MACHINE_ARCH} == "amd64"
beforedepend ${OBJS}: machine
.endif

=== sys/compat/freebsd32/Makefile ===
# Makefile for syscall tables
#
# $FreeBSD$

all:
	@echo "make sysent only"

sysent:  freebsd32_sysent.c freebsd32_syscall.h freebsd32_proto.h

freebsd32_sysent.c freebsd32_syscalls.c freebsd32_syscall.h freebsd32_proto.h: \
	    ../../kern/makesyscalls.sh syscalls.master syscalls.conf
	-mv -f freebsd32_sysent.c freebsd32_sysent.c.bak
	-mv -f freebsd32_syscalls.c freebsd32_syscalls.c.bak
	-mv -f freebsd32_syscall.h freebsd32_syscall.h.bak
	-mv -f freebsd32_proto.h freebsd32_proto.h.bak
	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf

clean:
	rm -f freebsd32_sysent.c freebsd32_syscalls.c freebsd32_syscall.h freebsd32_proto.h

=== sys/i386/linux/Makefile ===
# Makefile for syscall tables
#
# $FreeBSD$

all:
	@echo "make sysent only"

sysent:  linux_sysent.c linux_syscall.h linux_proto.h

linux_sysent.c linux_syscall.h linux_proto.h: ../../kern/makesyscalls.sh \
		syscalls.master syscalls.conf
	-mv -f linux_sysent.c linux_sysent.c.bak
	-mv -f linux_syscall.h linux_syscall.h.bak
	-mv -f linux_proto.h linux_proto.h.bak
	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf

=== sys/modules/acpi/Makefile ===
# $FreeBSD$

.if ${MACHINE} == "i386"
SUBDIR=		acpi
.endif

SUBDIR+=	acpi_aiboost acpi_asus acpi_fujitsu acpi_hp acpi_ibm	\
		acpi_panasonic acpi_sony acpi_toshiba acpi_video	\
		acpi_dock acpi_wmi aibs

.include <bsd.subdir.mk>

=== sys/modules/agp/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../dev/agp

KMOD=	agp
SRCS=	agp.c agp_if.c
.if ${MACHINE_ARCH} == "i386"
SRCS+=	agp_i810.c agp_intel.c agp_via.c agp_sis.c agp_ali.c agp_amd.c \
	agp_nvidia.c agp_ati.c
.endif
.if ${MACHINE} == "i386"
SRCS+=	agp_amd64.c
.endif
.if  ${MACHINE_ARCH} == "amd64"
SRCS+=	agp_amd64.c agp_i810.c agp_via.c
.endif
SRCS+=	device_if.h bus_if.h agp_if.h pci_if.h
SRCS+=	opt_agp.h opt_bus.h
MFILES=	kern/device_if.m kern/bus_if.m dev/agp/agp_if.m dev/pci/pci_if.m
WERROR=

EXPORT_SYMS=	agp_find_device		\
		agp_state		\
		agp_acquire		\
		agp_release		\
		agp_enable		\
		agp_alloc_memory	\
		agp_free_memory		\
		agp_bind_memory		\
		agp_unbind_memory	\
		agp_memory_info

.include <bsd.kmod.mk>

=== sys/modules/ahb/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../dev/ahb

KMOD=	ahb
SRCS=	ahb.c opt_cam.h device_if.h bus_if.h eisa_if.h opt_scsi.h

.if !defined(KERNBUILDDIR)
opt_scsi.h:
	echo "#define SCSI_DELAY 15000" > ${.TARGET}
.endif

.include <bsd.kmod.mk>

=== sys/modules/amr/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../dev/amr

SUBDIR= amr_cam
.if ${MACHINE_ARCH} == "i386" || ${MACHINE_ARCH} == "amd64"
SUBDIR+= amr_linux
.endif

KMOD=	amr
SRCS=	amr.c amr_pci.c amr_disk.c device_if.h bus_if.h pci_if.h

# Enable a questionable optimisation for newer adapters
#CFLAGS+= -DAMR_QUARTZ_GOFASTER

# Debugging
#CFLAGS+= -DAMR_DEBUG=3

.include <bsd.kmod.mk>

=== sys/modules/ata/Makefile ===
# $FreeBSD$

SUBDIR = atacore
SUBDIR += atacard
.if ${MACHINE} == "pc98"
SUBDIR += atacbus
.else
SUBDIR += ataisa
.endif
SUBDIR += atapci 
SUBDIR += atadisk atapicd atapifd atapist ataraid atapicam #atacam

.include <bsd.subdir.mk>

=== debian/changelog ===
kfreebsd-8 (8.2-15) unstable; urgency=low

  * Build udebs for the installer.

 -- Robert Millan <rmh@debian.org>  Fri, 25 Nov 2011 19:01:44 +0100

kfreebsd-8 (8.2-14) unstable; urgency=high

  * Fix installability problem on non-kfreebsd platforms.

 -- Robert Millan <rmh@debian.org>  Fri, 18 Nov 2011 19:28:47 +0100

kfreebsd-8 (8.2-13) unstable; urgency=low

  * Remove gen-ld-u-options / 020_linker.diff kludge, replace it with
    backport of upstream fix (r215137).
  * Mark kfreebsd-headers-@version@-@abiname@ as kfreebsd-any.
  * Depend on package providing devd.

 -- Robert Millan <rmh@debian.org>  Tue, 08 Nov 2011 21:52:27 +0100

kfreebsd-8 (8.2-12) unstable; urgency=low

  * Enable TEKEN_XTERM.
  * Backport libteken and syscons from 9-STABLE (r226626).
  * Recover 918_delete_key.diff patch from r3199.  (Closes: #605065)

 -- Robert Millan <rmh@debian.org>  Tue, 01 Nov 2011 13:51:36 +0100

kfreebsd-8 (8.2-11) unstable; urgency=low

  [ Aurelien Jarno ]
  * Update 000_unix_socket_overflow.diff from the second security advisory,
    fixing the same issue on the Linux compatibility layer. Closes: #645377.

  [ Robert Millan ]
  * Fix panic on early boot.  (Closes: #644417)
    - Switch back to GCC 4.4.
    - Turn optimization down to -O1 (901_disable_optimization_2.diff).
  * Remove 907_cpu_class.diff (it breaks FreeBSD userland when running
    in a chroot on Debian kernel).

 -- Robert Millan <rmh@debian.org>  Thu, 27 Oct 2011 21:49:27 +0200

kfreebsd-8 (8.2-10) unstable; urgency=low

  [ Robert Millan ]
  * Disable -frename-registers on i386.  I enabled it in 2006 only because I
    mistakenly thought upstream had done the same.  In fact, upstream only
    enabled this flag on amd64.  See SVN revision 1302.

  [ Petr Salinger ]
  * Add 918_unix_socket_overflow.diff, to fix up breakage in our userland
    after 000_unix_socket_overflow.diff. Closes: #645527.

 -- Robert Millan <rmh@debian.org>  Mon, 17 Oct 2011 20:32:16 +0200

kfreebsd-8 (8.2-9) unstable; urgency=high

  * 000_unix_socket_overflow.diff: Fix for FreeBSD-SA-11:05.unix.
    (Closes: #645377)

 -- Robert Millan <rmh@debian.org>  Sun, 16 Oct 2011 10:44:30 +0200

kfreebsd-8 (8.2-8) unstable; urgency=high

  [ Petr Salinger ]
  * extend ld_target detection

  [ Robert Millan ]
  * Fix panic on early boot.  (Closes: #644417)
    - Switch back to GCC 4.4
    - 005_gcc46.diff: Add -fno-gcse to COPTFLAGS to fix GCC >= 4.4 builds.

 -- Robert Millan <rmh@debian.org>  Sat, 08 Oct 2011 01:01:34 +0200

kfreebsd-8 (8.2-7) unstable; urgency=low

  * Replace msk backport patch with version from 8-STABLE (instead of
    9-CURRRENT).
  * Fix a pair of FTBFS on hurd-i386.
  * Provide "kfreebsd-headers" virtual package in kfreebsd-headers-
    @version@-@abiname@-@flavor@.
  * Loosen freebsd-utils dependency (8.1-5 already provides proper devd
    support now that #630614 has been backported).
  * 000_proc_swaps.diff: Implement /proc/swaps.

 -- Robert Millan <rmh@debian.org>  Mon, 08 Aug 2011 12:19:45 +0000

kfreebsd-8 (8.2-6) unstable; urgency=low

  * Only depend on freebsd-utils and kldutils on [kfreebsd-any].
  * 002_maxpathlen.diff: Fix FTBFS on hurd-i386.
  * Remove versioned dependency that confused buildds.

 -- Robert Millan <rmh@debian.org>  Sun, 10 Jul 2011 02:09:59 +0200

kfreebsd-8 (8.2-5) unstable; urgency=low

  * Disable buggy 009_disable_duped_modules.diff.  It was disabling many
    more modules than built into kernel (e.g. all USB modules).
  * Build-depend on sane versions of freebsd-buildutils (see #632600).

 -- Robert Millan <rmh@debian.org>  Mon, 04 Jul 2011 21:52:38 +0200

kfreebsd-8 (8.2-4) unstable; urgency=low

  * Add sys/conf/kmod_syms.awk, sys/kern/bus_if.m, sys/dev/pci/pci_if.m,
    sys/kern/device_if.m, sys/tools/makeobjops.awk and sys/machine symlink
    to header package.
  * Require either libsbuf-dev or kfreebsd-kernel-headers that provides
    a valid <sys/sbuf.h>.
  * Remove drivers for USB devices from kernel, now that devd autoloads
    them.
  * Extend ldscript non-kFreeBSD fix to support mipsel.
  * Allow building module-less kernels (needed for mipsel).
  * 000_uhid_nomatch.diff: Cherry-pick from HEAD (Fix for "nomatch" event
    for ums and ukbd drivers when uhid is loaded).

 -- Robert Millan <rmh@debian.org>  Sun, 03 Jul 2011 15:40:09 +0200

kfreebsd-8 (8.2-3) unstable; urgency=medium

  * Fix net802.11 stack kernel memory disclosure (CVE-2011-2480).
    (Closes: #631160)
    - 000_net80211_disclosure.diff

 -- Robert Millan <rmh@debian.org>  Fri, 24 Jun 2011 16:24:58 +0200

kfreebsd-8 (8.2-2) unstable; urgency=low

  [ Guillem Jover ]
  * Now using Standards-Version 3.9.2 (no changes needed).
  * Switch to source format “3.0 (quilt)”.
    - Remove quilt from Build-Depends.
    - Remove patch target in debian/rules.
    - Remove now unneeded README.source.
    - Refresh all patches.

  [ Robert Millan ]
  * Add lintian override for "embedded-library" (zlib.ko).
  * Automatically propagate GCC version dependency to debian/control.
  * Add "(meta-package)" to Description of meta-packages to make lintian happy.
  * Add myself to Uploaders.
  * Build by GCC 4.6.  (Closes: #594288)
  * Add conf/kern.mk, conf/kmod.mk, kern/vnode_if.src, and
    tools/vnode_if.awk to kfreebsd-headers-8.2-1.  (Closes: #630509)
  * Merge backported if_msk driver from HEAD.  (Closes: #628954)
    - 000_msk_backport_from_HEAD.diff

  [ Petr Salinger ]
  * Add 111_linprocfs_kthread.diff. Closes: #630104.

 -- Robert Millan <rmh@debian.org>  Fri, 17 Jun 2011 15:35:49 +0200

kfreebsd-8 (8.2-1) unstable; urgency=low

  [ Robert Millan ]
  * New upstream release.
    - 000_adaptive_machine_arch.diff: Remove (merged).
    - 000_ata.diff: Remove (merged).
    - 000_ufs_lookup.diff: Remove (merged).
    - 004_xargs.diff: Resync.
    - 102_POLL_HUP.diff: Remove (merged).
    - 104_linprocfs.diff: Remove (merged).
    - 904_dev_full.diff: Resync.
    - 999_firmware.diff: Resync.


=== debian/control ===
Source: kfreebsd-8
Section: kernel
Priority: optional
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>, Guillem Jover <guillem@debian.org>, Robert Millan <rmh@debian.org>
Vcs-Browser: http://svn.debian.org/wsvn/glibc-bsd/trunk/kfreebsd-8/
Vcs-Svn: svn://svn.debian.org/glibc-bsd/trunk/kfreebsd-8/
Build-Depends: debhelper (>= 5.0.0), bzip2, sharutils, flex-old | flex,
 freebsd-buildutils (>= 8.1-2) [!kfreebsd-any] | freebsd-buildutils (>= 7) [kfreebsd-any],
 gcc-4.4, libdb-dev,
 libbsd-dev,
 libsbuf-dev, libsbuf-dev (>= 8.2-2) | kfreebsd-kernel-headers (<< 0.56),
 freebsd-buildutils (>= 8.2-4) [any-mipsel],
 kernel-wedge (>= 2.79) [kfreebsd-any],
Standards-Version: 3.9.2

Package: kfreebsd-source-8.2
Architecture: all
Depends: ${misc:Depends}
Recommends: freebsd-buildutils (>= 7)
Provides: kfreebsd-source-8, kfreebsd-source
Description: source code for kernel of FreeBSD 8.2 with Debian patches
 This package provides the source code for kernel of FreeBSD 8.2, base of
 a GNU/kFreeBSD system.

Package: kfreebsd-headers-8.2-1
Architecture: any
Depends: ${misc:Depends}
Description: Common architecture-specific header files for kernel of FreeBSD 8.2
 This package provides the architecture-specific common kernel header files for
 kernel of FreeBSD 8.2, generally used for building out-of-tree kernel
 modules. To obtain a complete set of headers you also need to install the
 kfreebsd-headers-8.2-1-(flavour) package, matching the flavour of the
 kernel you intend the build for. To obtain such a set for the currently running
 kernel it is sufficient to run a command
 .
 apt-get install kfreebsd-headers-$(uname -r)
 .
 and it will be unpacked in /usr/src/kfreebsd-headers-8.2-1-(flavour)

Package: kfreebsd-image-8.2-1-amd64
Architecture: any-amd64
Depends: ${misc:Depends},
 freebsd-utils (>= 8.1-5) [kfreebsd-any], kldutils (>= 7.1) [kfreebsd-any],
 devd [kfreebsd-any] | freebsd-utils (<< 8.2+ds2-9) [kfreebsd-any],
# Policy-conformant keyboard mappings (see #605777)
 kbdcontrol (>= 8.2+ds2-6) [kfreebsd-any],
Conflicts: kfreebsd-loader (<< 5.4-1.3)
Provides: kfreebsd-image-8, kfreebsd-image
Recommends: 
Description: kernel of FreeBSD 8.2 image
 This package provides the binary image and pre-built loadable modules for
 the kernel of FreeBSD 8.2, base of a GNU/kFreeBSD system.
 .
 This package is compiled for a amd64-class machine.

Package: kfreebsd-image-8-amd64
Architecture: any-amd64
Depends: kfreebsd-image-8.2-1-amd64, ${misc:Depends}
Description: kernel of FreeBSD 8 image (meta-package)
 This package depends on the latest binary image for kernel of FreeBSD 8 on
 amd64-class machines.

Package: kfreebsd-headers-8.2-1-amd64
Architecture: any-amd64
Provides: kfreebsd-headers-8, kfreebsd-headers
Depends: kfreebsd-headers-8.2-1 (= ${binary:Version}), ${misc:Depends}
Description: header files for kernel of FreeBSD 8.2
 This package provides the header files for kernel of FreeBSD 8.2, generally
 used for building out-of-tree kernel modules. These files are going to be
 installed into /usr/src/kfreebsd-headers-8.2-1-amd64, and can be
 used for building modules that load into the kernel provided by the
 kfreebsd-image-8.2-1-amd64 package.

Package: kfreebsd-headers-8-amd64
Architecture: any-amd64
Depends: kfreebsd-headers-8.2-1-amd64, ${misc:Depends}
Description: header files for kernel of FreeBSD 8 (meta-package)
 This package depends on the latest header files for kernel of FreeBSD 8 on
 amd64-class machines.


Package: kernel-image-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: kernel-image, ata-modules, cdrom-core-modules, core-modules, crc-modules, ext2-modules, ide-core-modules, ide-modules, input-modules, mmc-core-modules, mouse-modules, nic-pcmcia-modules, nic-usb-modules, nls-core-modules, pata-modules, pcmcia-modules, pcmcia-storage-modules, rtc-modules, scsi-common-modules, serial-modules, ufs-modules, uinput-modules, usb-modules, usb-serial-modules, usb-storage-modules
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: FreeBSD kernel binary image for the Debian installer
 This package contains the FreeBSD kernel image for the Debian installer
 boot images. It does _not_ provide a usable kernel for your full
 Debian system.

Package: nic-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: nic-modules
Depends: kernel-image-8.2-1-amd64-di, nic-shared-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Common NIC drivers
 This package contains common NIC drivers for the kernel.

Package: nic-wireless-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: nic-wireless-modules
Depends: kernel-image-8.2-1-amd64-di, nic-shared-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Wireless NIC drivers
 This package contains wireless NIC drivers for the kernel.
 Includes crypto modules only needed for wireless (WEP).

Package: nic-shared-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: nic-shared-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Shared NIC drivers
 This package contains NIC drivers needed by combinations of nic-modules,
 nic-extra-modules, nic-pcmcia-modules, and nic-wireless-modules.

Package: serial-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: serial-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: optional
Description: Serial drivers
 This package contains serial drivers for the kernel.

Package: ppp-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: ppp-modules
Depends: kernel-image-8.2-1-amd64-di, serial-modules-8.2-1-amd64-di, zlib-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: optional
Description: PPP drivers
 This package contains PPP drivers for the kernel.

Package: cdrom-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: cdrom-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: optional
Description: Esoteric CDROM drivers
 This package contains esoteric CDROM drivers for the kernel.

Package: scsi-core-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: scsi-core-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Core SCSI subsystem
 This package contains the core SCSI subsystem for the kernel.

Package: scsi-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: scsi-modules
Depends: kernel-image-8.2-1-amd64-di, scsi-core-modules-8.2-1-amd64-di, parport-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: SCSI drivers
 This package contains SCSI drivers for the kernel.

Package: scsi-extra-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: scsi-extra-modules
Depends: scsi-modules-8.2-1-amd64-di, scsi-core-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Uncommon SCSI drivers
 This package contains uncommon SCSI drivers for the kernel.
 This includes SCSI RAID drivers, and some of the less common SCSI
 controllers.

Package: plip-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: plip-modules
Depends: kernel-image-8.2-1-amd64-di, parport-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: optional
Description: PLIP drivers
 This package contains PLIP drivers for the kernel.

Package: floppy-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: floppy-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Floppy driver
 This package contains the floppy driver for the kernel.

Package: loop-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: loop-modules
Depends: kernel-image-8.2-1-amd64-di, zlib-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: Loopback filesystem support
 This package contains loopback filesystem support for the kernel.

Package: ipv6-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: ipv6-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: IPv6 driver
 This package contains the IPv6 driver for the kernel.

Package: nls-core-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: nls-core-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: Core NLS support
 This package contains basic NLS support modules for the kernel.

Package: ext2-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: ext2-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: EXT2 filesystem support
 This package contains the EXT2 filesystem module for the kernel.

Package: isofs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: isofs-modules
Depends: kernel-image-8.2-1-amd64-di, nls-core-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: ISOFS filesystem support
 This package contains the ISOFS filesystem module for the kernel.

Package: ntfs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: ntfs-modules
Depends: kernel-image-8.2-1-amd64-di, nls-core-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: NTFS filesystem support
 This package contains the NTFS file system module for the kernel.

Package: reiserfs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: reiserfs-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: Reiser filesystem support
 This package contains the Reiser filesystem module for the kernel.

Package: xfs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: xfs-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: standard
Description: XFS filesystem support
 This package contains the XFS filesystem module for the kernel.

Package: fat-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: fat-modules
Depends: kernel-image-8.2-1-amd64-di, nls-core-modules-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: FAT filesystem support
 This package contains the FAT and VFAT filesystem modules for the kernel.

Package: zfs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: zfs-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: ZFS filesystem support
 This package contains the ZFS filesystem module for the kernel.

Package: nfs-modules-8.2-1-amd64-di
XC-Package-Type: udeb
Provides: nfs-modules
Depends: kernel-image-8.2-1-amd64-di
Architecture: kfreebsd-amd64
XB-Kernel-Version: 8.2-1-amd64
Section: debian-installer
Priority: extra
Description: NFS filesystem support

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

SHELL = bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_OS	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_CPU	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
tar_version	:= $(shell echo $(full_version) | sed -e 's/-.*//g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')
revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')
cpu		:= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
config_files	:= $(wildcard debian/arch/$(cpu)/*.config)
flavours	:= $(config_files:debian/arch/$(cpu)/%.config=%)
configfile	:= DEBCUSTOM
abiname		:= 1
ld_target	:= $(shell ld --help | sed -ne "s/[^ :]*: supported targets: \([^ ]*\) .*/\1/p")
gcc_version	:= 4.4

ifeq ($(cpu), mipsel)
kfreebsd_cpu	:= mips
else
kfreebsd_cpu	:= $(cpu)
endif

SVN		:= http://svn.freebsd.org/base/release/$(version).0
#SVN		:= http://svn.freebsd.org/base/releng/$(version)
#SVN		:= http://svn.freebsd.org/base/stable/$(major)
SOURCE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-source-$(version)
IMAGE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-image-$(version)-$(abiname)
HEADERS_PACKAGE	:= $(CURDIR)/debian/kfreebsd-headers-$(version)-$(abiname)
SRC_TAR		:= kfreebsd-source-$(version).tar.xz
SRC_DIR		:= kfreebsd-source-$(version)
HEADERS_DIR	:= kfreebsd-headers-$(version)-$(abiname)
FLAVOR_DIR	:= flavor-$(version)-$(abiname)
ORIG_DIR	:= kfreebsd-$(major)-$(tar_version)
ORIG_TAR	:= kfreebsd-$(major)_$(tar_version).orig.tar.gz
MAKE		:= make MACHINE_ARCH=$(kfreebsd_cpu) CC=gcc-$(gcc_version) WERROR=
PATH		:= $(CURDIR)/config:/usr/lib/freebsd:$(PATH)

get-orig-source:
	rm -rf $(ORIG_DIR)
	for i in sys usr.sbin/config ; do \
		svn export $(SVN)/$$i $(ORIG_DIR)/$$i ; \
	done
	cd $(ORIG_DIR) && $(CURDIR)/debian/prune.sh
	tar --numeric-owner --owner 0 --group 0 -czf ../$(ORIG_TAR) $(ORIG_DIR)
	rm -rf $(ORIG_DIR)

control: clean
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		KW_CONFIG_DIR=debian/arch/$$arch/installer ; \
		if test -e $$KW_CONFIG_DIR ; then \
			for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
				flavor=$${config/.config/} ; \
				if test -e debian/arch/$$arch/$$flavor.installer ; then \
					echo "kfreebsd-$$arch $(version)-$(abiname) $$flavor $(version)-$(abiname)-$$flavor - -" ; \
				fi ; \
			done > $$KW_CONFIG_DIR/kernel-versions ; \
		fi ; \
		echo ; \
	done
	sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" -e "s/@gcc_version@/$(gcc_version)/g" \
		$(CURDIR)/debian/control.in > $(CURDIR)/debian/control
	echo >> $(CURDIR)/debian/control
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
			flavor=$${config/.config/} ; \
			recommends= ; \
			test -f $(CURDIR)/debian/arch/$$arch/$$flavor.defines && recommends=`awk '/^Recommends: / {print $$2}' $(CURDIR)/debian/arch/$$arch/$$flavor.defines` ; \
			sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" -e "s/@arch@/$$arch/g" -e "s/@recommends@/$$recommends/g" \
				$(CURDIR)/debian/control.flavor.in ; \
			echo ; \
		done ; \
		export KW_CONFIG_DIR=debian/arch/$$arch/installer ; \
		if test -e $$KW_CONFIG_DIR/kernel-versions ; then \
			kernel-wedge gen-control ; \
		fi ; \
		echo ; \
	done >> $(CURDIR)/debian/control

clean:
	dh_testdir
	dh_testroot
	rm -rf src kfreebsd-source-* flavor-* config
	rm -f debian/kfreebsd-image-*.preinst
	rm -f debian/kfreebsd-image-*.prerm
	rm -f debian/kfreebsd-image-*.postinst
	rm -f debian/kfreebsd-image-*.postrm

	rm -f *-stamp
	dh_clean

src: src-stamp
src-stamp:
	mkdir $(CURDIR)/src
	cp -af $(CURDIR)/sys $(CURDIR)/usr.sbin $(CURDIR)/src

	set -e ; find src/sys -type f | (while read i ; do \
		sed -i $$i \
		-e 's/defined\( \|\t\)*(\( \|\t\)*__FreeBSD__\( \|\t\)*)/1/g' \
		-e 's/#\( \|\t\)*ifdef\( \|\t\)*__FreeBSD__/#if 1/g' \
		-e 's/#\( \|\t\)*ifndef\( \|\t\)*__FreeBSD__/#if 0/g' \
		-e 's/defined\( \|\t\)*(\( \|\t\)*\(__linux__\|linux\)\( \|\t\)*)/0/g' \
		-e 's/#\( \|\t\)*ifdef\( \|\t\)*\(__linux__\|linux\)/#if 0/g' \
		-e 's/#\( \|\t\)*ifndef\( \|\t\)*\(__linux__\|linux\)/#if 1/g' \
		-e 's/__FreeBSD__/$(major)/g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*<sys/device.h>,,g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*<dev/rndvar.h>,,g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*<sys/pool.h>,,g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*<netinet/ip_ipsp.h>,,g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*\(<\|"\)bpfilter.h\(>\|"\),,g' \
		-e 's,#\( \|\t\)*include\( \|\t\)*\(<\|"\)pflog.h\(>\|"\),,g' \
	; done)

	touch src-stamp

build-indep: build-indep-stamp
build-indep-stamp: src
	dh_testdir

	cp -af src $(SRC_DIR)

	touch build-indep-stamp

build: build-arch build-indep

install-indep: install-indep-stamp
install-indep-stamp: build-indep
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -i

	mkdir -p $(SOURCE_PACKAGE)/usr/src
	chown -R root.src $(SRC_DIR)
	tar cfJ $(SOURCE_PACKAGE)/usr/src/$(SRC_TAR) $(SRC_DIR)

	touch install-indep-stamp

config: config-stamp
config-stamp: src
	rm -rf config
	cp -af src/usr.sbin/config config
	CFLAGS="-D__va_list=__builtin_va_list" $(MAKE) -C config
	touch $@

build-arch: $(foreach flavor,$(flavours),build-flavor-$(flavor)-stamp)
src-flavor-%-stamp: src config
	cp -af src $(FLAVOR_DIR)-$*
	touch $@
build-flavor-%-stamp: src-flavor-%-stamp
	# Add the abiname and the flavor to the kernel version
	sed -i -e 's/^RELEASE=".*"/RELEASE="$(version)-$(abiname)-$*"/g' $(FLAVOR_DIR)-$*/sys/conf/newvers.sh

	# Change ident to the kernel version
	sed -i -e 's/^i=.*/i="Debian $* ($(full_version))"/g' $(FLAVOR_DIR)-$*/sys/conf/newvers.sh

	# Set /lib/modules/${RELEASE} as module dir
	sed -i -e 's,^KODIR?=.*,KODIR="/lib/modules/$(version)-$(abiname)-$*",g' $(FLAVOR_DIR)-$*/sys/conf/kern.pre.mk
	sed -i -e '/^static char linker_path/s,".*","/lib/modules/$(version)-$(abiname)-$*",g' $(FLAVOR_DIR)-$*/sys/kern/kern_linker.c

	# Always set explicit link target to match with ld's implicit target (needed
	# to build on non-kFreeBSD)
	sed -i \
		-e 's/elf32-i386-freebsd/$(ld_target)/g' \
		-e 's/elf64-x86-64-freebsd/$(ld_target)/g' \
		-e 's/elf32-tradlittlemips-freebsd/$(ld_target)/g' \
		-e 's/elf32-tradbigmips-freebsd/$(ld_target)/g' \
	$(FLAVOR_DIR)-$*/sys/conf/ldscript.$(kfreebsd_cpu)

	# Configure the kernel
	cp debian/arch/$(cpu)/$*.config $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf/
	ln -sf $*.config $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf/$(configfile)
	cd $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf \
		&& config $(configfile)

	# Build it
	$(MAKE) -C $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/compile/$(configfile)/ depend
	$(MAKE) -C $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/compile/$(configfile)/

	touch build-flavor-$*-stamp

install-common-stamp: src
	dh_testdir
	dh_testroot
	mkdir -p $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR)
	cd src \
		&& find . -type f -name "*.h" -not -regex ".*modules.*" -not -regex ".*sys/$(kfreebsd_cpu)/.*" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR) \;

	mkdir -p $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR)/conf
	cd src && cp --parents \
		sys/conf/kern.mk \
		sys/conf/kmod.mk \
		sys/conf/kmod_syms.awk \
		sys/kern/bus_if.m \
		sys/dev/pci/pci_if.m \
		sys/kern/device_if.m \
		sys/kern/vnode_if.src \
		sys/tools/vnode_if.awk \
		sys/tools/makeobjops.awk \
		$(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR)

	find $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR) -type f -exec chmod 644 {} \;
	find $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR) -type f -name "*.awk" -exec chmod 755 {} \;

	touch install-common-stamp

install-arch: $(foreach flavor,$(flavours),install-flavor-$(flavor)-stamp)
